import React, { useState, useContext, forwardRef, useImperativeHandle } from 'react'
import FormRender, { useForm } from 'form-render'
import { ConfigProvider } from 'antd'
import widgets from '../widgets'

const XRender = (props, ref) => {

  useImperativeHandle(ref, () => (
    {
      getValues
    }
  ))

  const { schema } = props
  const { getPrefixCls } = useContext(ConfigProvider.ConfigContext)
  const prefixCls = getPrefixCls('pandaXform')
  const pandaXform = getPrefixCls()

  const form = useForm()

  const getValues = async () => {
    let { data, errors } = await form.submit()
    // console.log('form', form, errorFields)
    // form.formData()
    let formValue = []
    Object.keys(data).map((k) => {
      Object.keys(data[k]).map((key) => {
        formValue.push({ fieldName: key, fieldValue: data[k][key] + '' })
      })
    })
    return {
      formValue,
      errors,
    }
  }

  return (
    <div className={prefixCls}>
      <FormRender
        configProvider={{ prefixCls: pandaXform }}
        form={form}
        schema={schema}
        mapping={{
          object: 'Header',
        }}
        widgets={widgets}
      />
    </div>
  )

}

export default forwardRef(XRender)
