import React, { useContext, useEffect, useMemo, useState } from 'react'
import { Input, Select, message } from 'antd'
import { LoadTableFields, ReloadTableFields } from '../../../../../apis/process'

const FieldNames = (props) => {

  const { value, onChange, addons } = props
  const { tableNameParent } = addons.formData

  const [fieldName, setFieldName] = useState([])

  const selectChange = (value) => {
    console.log('value', value)
    onChange(value)
  }

  const onFocus = async () => {
    if (!tableNameParent) {
      return message.info('缺少表名!')
    }
    const { data } = await ReloadTableFields({ tableName: tableNameParent })
    if (Array.isArray(data.root)) {
      setFieldName(data.root)
    }
    console.log('props', props)
  }

  useEffect(() => {
    if (value && value.includes('#/')) {
      let array = value.split('/')
      if (array.length === 3) {
        onChange(array[2])
      }
    }
  }, [value])

  return (
    <Select
      onFocus={onFocus}
      onChange={selectChange}
      style={{ width: '100%' }}
      showSearch
      optionFilterProp='children'
      value={value}
    >
      {
        fieldName.map(v => <Select.Option key={v.name} value={v.name}>{v.name}</Select.Option>)
      }
    </Select>
  )
}

export default FieldNames